enum Permission {
  DASHBOARD = "dashboard",
  LINKS_VIEW = "links.view",
  LINKS_CREATE = "links.create",
  LINKS_UPDATE = "links.update",
  LINKS_DELETE = "links.delete",
  ADMIN_ANALYTICS = "admin.analytics",
  ADMIN_LINKS_VIEW = "admin.links.view",
  ADMIN_LINKS_UPDATE = "admin.links.update",
  ADMIN_LINKS_DELETE = "admin.links.delete",
  ADMIN_USERS_VIEW = "admin.users.view",
  ADMIN_USERS_CREATE = "admin.users.create",
  ADMIN_USERS_UPDATE = "admin.users.update",
  ADMIN_USERS_DELETE = "admin.users.delete",
  ADMIN_USER_ROLES_VIEW = "admin.user_roles.view",
  ADMIN_USER_ROLES_CREATE = "admin.user_roles.create",
  ADMIN_USER_ROLES_UPDATE = "admin.user_roles.update",
  ADMIN_USER_ROLES_DELETE = "admin.user_roles.delete",
  ADMIN_DOMAINS_VIEW = "admin.domains.view",
  ADMIN_DOMAINS_CREATE = "admin.domains.create",
  ADMIN_DOMAINS_UPDATE = "admin.domains.update",
  ADMIN_DOMAINS_DELETE = "admin.domains.delete",
  ADMIN_SETTINGS_GENERAL = "admin.settings.general",
  ADMIN_SETTINGS_LINKS = "admin.settings.links",
  ADMIN_SETTINGS_LANDING = "admin.settings.landing",
  ADMIN_SETTINGS_SEO = "admin.settings.seo",
  ADMIN_SETTINGS_APPEARANCE = "admin.settings.appearance",
  ADMIN_SETTINGS_AUTHENTICATION = "admin.settings.authentication",
  ADMIN_SETTINGS_OUTGOING_MAIL = "admin.settings.outgoing-mail",
}

export { Permission };

export const permissions = computed<Record<string, Permission[]>>(() => ({
  dashboard: [Permission.DASHBOARD],
  links: [Permission.LINKS_VIEW, Permission.LINKS_CREATE, Permission.LINKS_UPDATE, Permission.LINKS_DELETE],
  admin_analytics: [Permission.ADMIN_ANALYTICS],
  admin_links: [Permission.ADMIN_LINKS_VIEW, Permission.ADMIN_LINKS_UPDATE, Permission.ADMIN_LINKS_DELETE],
  admin_users: [Permission.ADMIN_USERS_VIEW, Permission.ADMIN_USERS_CREATE, Permission.ADMIN_USERS_UPDATE, Permission.ADMIN_USERS_DELETE],
  admin_user_roles: [Permission.ADMIN_USER_ROLES_VIEW, Permission.ADMIN_USER_ROLES_CREATE, Permission.ADMIN_USER_ROLES_UPDATE, Permission.ADMIN_USER_ROLES_DELETE],
  admin_domains: [Permission.ADMIN_DOMAINS_VIEW, Permission.ADMIN_DOMAINS_CREATE, Permission.ADMIN_DOMAINS_UPDATE, Permission.ADMIN_DOMAINS_DELETE],
  admin_settings: [
    Permission.ADMIN_SETTINGS_GENERAL,
    Permission.ADMIN_SETTINGS_LINKS,
    Permission.ADMIN_SETTINGS_LANDING,
    Permission.ADMIN_SETTINGS_SEO,
    Permission.ADMIN_SETTINGS_APPEARANCE,
    Permission.ADMIN_SETTINGS_AUTHENTICATION,
    Permission.ADMIN_SETTINGS_OUTGOING_MAIL,
  ],
}));
